Loading...
Searching...
No Matches
scalar_binary_traits< F >::hint< A1, A2, R >

## Detailed Description

template<class F>
template<class A1, class A2, class R>
struct rheolef::details::scalar_binary_traits< F >::hint< A1, A2, R >

Definition at line 1380 of file expression.h.

## Public Types

typedef scalar_traits< A1 >::type | S1
typedef scalar_traits< A2 >::type | S2
typedef scalar_traits< R >::type | S
typedef details::and_type< details::or_type< details::is_scalar< A1 >, is_undeterminated< A1 > >, details::or_type< details::is_scalar< A2 >, is_undeterminated< A2 > >, details::or_type< details::is_scalar< R >, is_undeterminated< R > > >::type | is_good
typedef std::conditional< is_undeterminated< A1 >::value, typenamestd::conditional< is_good::value, S1, binop_error< F, A1, A2, R > >::type, A1 >::type | first_argument_type
typedef std::conditional< is_undeterminated< A2 >::value, typenamestd::conditional< is_good::value, S2, binop_error< F, A1, A2, R > >::type, A2 >::type | second_argument_type
typedef std::conditional< is_undeterminated< R >::value, typenamestd::conditional< is_good::value, S, binop_error< F, A1, A2, R > >::type, R >::type | result_type

## Member Typedef Documentation

## S1

template<class F >
template<class A1 , class A2 , class R >

typedef scalar_traits<A1>::type S1

Definition at line 1381 of file expression.h.

## S2

template<class F >
template<class A1 , class A2 , class R >

typedef scalar_traits<A2>::type S2

Definition at line 1382 of file expression.h.

## S

template<class F >
template<class A1 , class A2 , class R >

typedef scalar_traits<R>::type S

Definition at line 1383 of file expression.h.

## is_good

template<class F >
template<class A1 , class A2 , class R >

typedef details::and_type<details::or_type<details::is_scalar<A1>,is_undeterminated<A1>>,details::or_type<details::is_scalar<A2>,is_undeterminated<A2>>,details::or_type<details::is_scalar<R>,is_undeterminated<R>>>::type is_good

Definition at line 1397 of file expression.h.

## first_argument_type

template<class F >
template<class A1 , class A2 , class R >

typedef std::conditional<is_undeterminated<A1>::value,typenamestd::conditional<is_good::value,S1,binop_error<F,A1,A2,R>>::type,A1>::type first_argument_type

Definition at line 1406 of file expression.h.

## second_argument_type

template<class F >
template<class A1 , class A2 , class R >

typedef std::conditional<is_undeterminated<A2>::value,typenamestd::conditional<is_good::value,S2,binop_error<F,A1,A2,R>>::type,A2>::type second_argument_type

Definition at line 1415 of file expression.h.

## result_type

template<class F >
template<class A1 , class A2 , class R >

typedef std::conditional<is_undeterminated<R>::value,typenamestd::conditional<is_good::value,S,binop_error<F,A1,A2,R>>::type,R>::type result_type

Definition at line 1424 of file expression.h.

The documentation for this struct was generated from the following file:

- /build/rheolef-dTNbRN/rheolef-7.2/main/lib/expression.h